
# python wrapper for package github.com/rudderlabs/wht-core-lib/wht/features within overall package pywht
# This is what you import to use the package.
# File is generated by gopy. Do not edit.
# gopy pkg -vm=python3 -output=out -name=pywht github.com/rudderlabs/wht-core-lib/wht

# the following is required to enable dlopen to open the _go.so file
import os,sys,inspect,collections
try:
	import collections.abc as _collections_abc
except ImportError:
	_collections_abc = collections

cwd = os.getcwd()
currentdir = os.path.dirname(os.path.abspath(inspect.getfile(inspect.currentframe())))
os.chdir(currentdir)
from pywht import _pywht
from pywht import go

os.chdir(cwd)

# to use this code in your end-user python file, import it as follows:
# from pywht import features
# and then refer to everything using features. prefix
# packages imported by this package listed below:

from pywht import base
from pywht import identity
from pywht import sources



# ---- Types ---

# Python type for slice []features.FeatureIdentifierDeclaration
class Slice_features_FeatureIdentifierDeclaration(go.GoClass):
	""""""
	def __init__(self, *args, **kwargs):
		"""
		handle=A Go-side object is always initialized with an explicit handle=arg
		otherwise parameter is a python list that we copy from
		"""
		self.index = 0
		if len(kwargs) == 1 and 'handle' in kwargs:
			self.handle = kwargs['handle']
			_pywht.IncRef(self.handle)
		elif len(args) == 1 and isinstance(args[0], go.GoClass):
			self.handle = args[0].handle
			_pywht.IncRef(self.handle)
		else:
			self.handle = _pywht.Slice_features_FeatureIdentifierDeclaration_CTor()
			_pywht.IncRef(self.handle)
			if len(args) > 0:
				if not isinstance(args[0], _collections_abc.Iterable):
					raise TypeError('Slice_features_FeatureIdentifierDeclaration.__init__ takes a sequence as argument')
				for elt in args[0]:
					self.append(elt)
	def __del__(self):
		_pywht.DecRef(self.handle)
	def __str__(self):
		s = 'features.Slice_features_FeatureIdentifierDeclaration len: ' + str(len(self)) + ' handle: ' + str(self.handle) + ' ['
		if len(self) < 120:
			s += ', '.join(map(str, self)) + ']'
		return s
	def __repr__(self):
		return 'features.Slice_features_FeatureIdentifierDeclaration([' + ', '.join(map(str, self)) + '])'
	def __len__(self):
		return _pywht.Slice_features_FeatureIdentifierDeclaration_len(self.handle)
	def __getitem__(self, key):
		if isinstance(key, slice):
			if key.step == None or key.step == 1:
				st = key.start
				ed = key.stop
				if st == None:
					st = 0
				if ed == None:
					ed = _pywht.Slice_features_FeatureIdentifierDeclaration_len(self.handle)
				return Slice_features_FeatureIdentifierDeclaration(handle=_pywht.Slice_features_FeatureIdentifierDeclaration_subslice(self.handle, st, ed))
			return [self[ii] for ii in range(*key.indices(len(self)))]
		elif isinstance(key, int):
			if key < 0:
				key += len(self)
			if key < 0 or key >= len(self):
				raise IndexError('slice index out of range')
			return FeatureIdentifierDeclaration(handle=_pywht.Slice_features_FeatureIdentifierDeclaration_elem(self.handle, key))
		else:
			raise TypeError('slice index invalid type')
	def __setitem__(self, idx, value):
		if idx < 0:
			idx += len(self)
		if idx < len(self):
			_pywht.Slice_features_FeatureIdentifierDeclaration_set(self.handle, idx, value.handle)
			return
		raise IndexError('slice index out of range')
	def __iadd__(self, value):
		if not isinstance(value, _collections_abc.Iterable):
			raise TypeError('Slice_features_FeatureIdentifierDeclaration.__iadd__ takes a sequence as argument')
		for elt in value:
			self.append(elt)
		return self
	def __iter__(self):
		self.index = 0
		return self
	def __next__(self):
		if self.index < len(self):
			rv = _pywht.Slice_features_FeatureIdentifierDeclaration_elem(self.handle, self.index)
			self.index = self.index + 1
			return rv
		raise StopIteration
	def append(self, value):
		_pywht.Slice_features_FeatureIdentifierDeclaration_append(self.handle, value.handle)
	def copy(self, src):
		""" copy emulates the go copy function, copying elements into this list from source list, up to min of size of each list """
		mx = min(len(self), len(src))
		for i in range(mx):
			self[i] = src[i]

# Python type for slice []identity.IdEdgeSignal
class Slice_identity_IdEdgeSignal(go.GoClass):
	""""""
	def __init__(self, *args, **kwargs):
		"""
		handle=A Go-side object is always initialized with an explicit handle=arg
		otherwise parameter is a python list that we copy from
		"""
		self.index = 0
		if len(kwargs) == 1 and 'handle' in kwargs:
			self.handle = kwargs['handle']
			_pywht.IncRef(self.handle)
		elif len(args) == 1 and isinstance(args[0], go.GoClass):
			self.handle = args[0].handle
			_pywht.IncRef(self.handle)
		else:
			self.handle = _pywht.Slice_identity_IdEdgeSignal_CTor()
			_pywht.IncRef(self.handle)
			if len(args) > 0:
				if not isinstance(args[0], _collections_abc.Iterable):
					raise TypeError('Slice_identity_IdEdgeSignal.__init__ takes a sequence as argument')
				for elt in args[0]:
					self.append(elt)
	def __del__(self):
		_pywht.DecRef(self.handle)
	def __str__(self):
		s = 'features.Slice_identity_IdEdgeSignal len: ' + str(len(self)) + ' handle: ' + str(self.handle) + ' ['
		if len(self) < 120:
			s += ', '.join(map(str, self)) + ']'
		return s
	def __repr__(self):
		return 'features.Slice_identity_IdEdgeSignal([' + ', '.join(map(str, self)) + '])'
	def __len__(self):
		return _pywht.Slice_identity_IdEdgeSignal_len(self.handle)
	def __getitem__(self, key):
		if isinstance(key, slice):
			if key.step == None or key.step == 1:
				st = key.start
				ed = key.stop
				if st == None:
					st = 0
				if ed == None:
					ed = _pywht.Slice_identity_IdEdgeSignal_len(self.handle)
				return Slice_identity_IdEdgeSignal(handle=_pywht.Slice_identity_IdEdgeSignal_subslice(self.handle, st, ed))
			return [self[ii] for ii in range(*key.indices(len(self)))]
		elif isinstance(key, int):
			if key < 0:
				key += len(self)
			if key < 0 or key >= len(self):
				raise IndexError('slice index out of range')
			return identity.IdEdgeSignal(handle=_pywht.Slice_identity_IdEdgeSignal_elem(self.handle, key))
		else:
			raise TypeError('slice index invalid type')
	def __setitem__(self, idx, value):
		if idx < 0:
			idx += len(self)
		if idx < len(self):
			_pywht.Slice_identity_IdEdgeSignal_set(self.handle, idx, value.handle)
			return
		raise IndexError('slice index out of range')
	def __iadd__(self, value):
		if not isinstance(value, _collections_abc.Iterable):
			raise TypeError('Slice_identity_IdEdgeSignal.__iadd__ takes a sequence as argument')
		for elt in value:
			self.append(elt)
		return self
	def __iter__(self):
		self.index = 0
		return self
	def __next__(self):
		if self.index < len(self):
			rv = _pywht.Slice_identity_IdEdgeSignal_elem(self.handle, self.index)
			self.index = self.index + 1
			return rv
		raise StopIteration
	def append(self, value):
		_pywht.Slice_identity_IdEdgeSignal_append(self.handle, value.handle)
	def copy(self, src):
		""" copy emulates the go copy function, copying elements into this list from source list, up to min of size of each list """
		mx = min(len(self), len(src))
		for i in range(mx):
			self[i] = src[i]

# Python type for slice []identity.IdStitchingModelInput
class Slice_identity_IdStitchingModelInput(go.GoClass):
	""""""
	def __init__(self, *args, **kwargs):
		"""
		handle=A Go-side object is always initialized with an explicit handle=arg
		otherwise parameter is a python list that we copy from
		"""
		self.index = 0
		if len(kwargs) == 1 and 'handle' in kwargs:
			self.handle = kwargs['handle']
			_pywht.IncRef(self.handle)
		elif len(args) == 1 and isinstance(args[0], go.GoClass):
			self.handle = args[0].handle
			_pywht.IncRef(self.handle)
		else:
			self.handle = _pywht.Slice_identity_IdStitchingModelInput_CTor()
			_pywht.IncRef(self.handle)
			if len(args) > 0:
				if not isinstance(args[0], _collections_abc.Iterable):
					raise TypeError('Slice_identity_IdStitchingModelInput.__init__ takes a sequence as argument')
				for elt in args[0]:
					self.append(elt)
	def __del__(self):
		_pywht.DecRef(self.handle)
	def __str__(self):
		s = 'features.Slice_identity_IdStitchingModelInput len: ' + str(len(self)) + ' handle: ' + str(self.handle) + ' ['
		if len(self) < 120:
			s += ', '.join(map(str, self)) + ']'
		return s
	def __repr__(self):
		return 'features.Slice_identity_IdStitchingModelInput([' + ', '.join(map(str, self)) + '])'
	def __len__(self):
		return _pywht.Slice_identity_IdStitchingModelInput_len(self.handle)
	def __getitem__(self, key):
		if isinstance(key, slice):
			if key.step == None or key.step == 1:
				st = key.start
				ed = key.stop
				if st == None:
					st = 0
				if ed == None:
					ed = _pywht.Slice_identity_IdStitchingModelInput_len(self.handle)
				return Slice_identity_IdStitchingModelInput(handle=_pywht.Slice_identity_IdStitchingModelInput_subslice(self.handle, st, ed))
			return [self[ii] for ii in range(*key.indices(len(self)))]
		elif isinstance(key, int):
			if key < 0:
				key += len(self)
			if key < 0 or key >= len(self):
				raise IndexError('slice index out of range')
			return identity.IdStitchingModelInput(handle=_pywht.Slice_identity_IdStitchingModelInput_elem(self.handle, key))
		else:
			raise TypeError('slice index invalid type')
	def __setitem__(self, idx, value):
		if idx < 0:
			idx += len(self)
		if idx < len(self):
			_pywht.Slice_identity_IdStitchingModelInput_set(self.handle, idx, value.handle)
			return
		raise IndexError('slice index out of range')
	def __iadd__(self, value):
		if not isinstance(value, _collections_abc.Iterable):
			raise TypeError('Slice_identity_IdStitchingModelInput.__iadd__ takes a sequence as argument')
		for elt in value:
			self.append(elt)
		return self
	def __iter__(self):
		self.index = 0
		return self
	def __next__(self):
		if self.index < len(self):
			rv = _pywht.Slice_identity_IdStitchingModelInput_elem(self.handle, self.index)
			self.index = self.index + 1
			return rv
		raise StopIteration
	def append(self, value):
		_pywht.Slice_identity_IdStitchingModelInput_append(self.handle, value.handle)
	def copy(self, src):
		""" copy emulates the go copy function, copying elements into this list from source list, up to min of size of each list """
		mx = min(len(self), len(src))
		for i in range(mx):
			self[i] = src[i]


#---- Enums from Go (collections of consts with same type) ---


#---- Constants from Go: Python can only ask that you please don't change these! ---


# ---- Global Variables: can only use functions to access ---


# ---- Interfaces ---


# ---- Structs ---

# Python type for struct features.FeatureVarDeclaration
class FeatureVarDeclaration(go.GoClass):
	""""""
	def __init__(self, *args, **kwargs):
		"""
		handle=A Go-side object is always initialized with an explicit handle=arg
		otherwise parameters can be unnamed in order of field names or named fields
		in which case a new Go object is constructed first
		"""
		if len(kwargs) == 1 and 'handle' in kwargs:
			self.handle = kwargs['handle']
			_pywht.IncRef(self.handle)
		elif len(args) == 1 and isinstance(args[0], go.GoClass):
			self.handle = args[0].handle
			_pywht.IncRef(self.handle)
		else:
			self.handle = _pywht.features_FeatureVarDeclaration_CTor()
			_pywht.IncRef(self.handle)
			if  0 < len(args):
				self.Feature = args[0]
			if "Feature" in kwargs:
				self.Feature = kwargs["Feature"]
			if  1 < len(args):
				self.Description = args[1]
			if "Description" in kwargs:
				self.Description = kwargs["Description"]
			if  2 < len(args):
				self.Value = args[2]
			if "Value" in kwargs:
				self.Value = kwargs["Value"]
	def __del__(self):
		_pywht.DecRef(self.handle)
	def __str__(self):
		pr = [(p, getattr(self, p)) for p in dir(self) if not p.startswith('__')]
		sv = 'features.FeatureVarDeclaration{'
		first = True
		for v in pr:
			if callable(v[1]):
				continue
			if first:
				first = False
			else:
				sv += ', '
			sv += v[0] + '=' + str(v[1])
		return sv + '}'
	def __repr__(self):
		pr = [(p, getattr(self, p)) for p in dir(self) if not p.startswith('__')]
		sv = 'features.FeatureVarDeclaration ( '
		for v in pr:
			if not callable(v[1]):
				sv += v[0] + '=' + str(v[1]) + ', '
		return sv + ')'
	@property
	def Feature(self):
		return _pywht.features_FeatureVarDeclaration_Feature_Get(self.handle)
	@Feature.setter
	def Feature(self, value):
		if isinstance(value, go.GoClass):
			_pywht.features_FeatureVarDeclaration_Feature_Set(self.handle, value.handle)
		else:
			_pywht.features_FeatureVarDeclaration_Feature_Set(self.handle, value)
	@property
	def Description(self):
		return _pywht.features_FeatureVarDeclaration_Description_Get(self.handle)
	@Description.setter
	def Description(self, value):
		if isinstance(value, go.GoClass):
			_pywht.features_FeatureVarDeclaration_Description_Set(self.handle, value.handle)
		else:
			_pywht.features_FeatureVarDeclaration_Description_Set(self.handle, value)
	@property
	def Value(self):
		return _pywht.features_FeatureVarDeclaration_Value_Get(self.handle)
	@Value.setter
	def Value(self, value):
		if isinstance(value, go.GoClass):
			_pywht.features_FeatureVarDeclaration_Value_Set(self.handle, value.handle)
		else:
			_pywht.features_FeatureVarDeclaration_Value_Set(self.handle, value)

# Python type for struct features.MacroDeclaration
class MacroDeclaration(go.GoClass):
	""""""
	def __init__(self, *args, **kwargs):
		"""
		handle=A Go-side object is always initialized with an explicit handle=arg
		otherwise parameters can be unnamed in order of field names or named fields
		in which case a new Go object is constructed first
		"""
		if len(kwargs) == 1 and 'handle' in kwargs:
			self.handle = kwargs['handle']
			_pywht.IncRef(self.handle)
		elif len(args) == 1 and isinstance(args[0], go.GoClass):
			self.handle = args[0].handle
			_pywht.IncRef(self.handle)
		else:
			self.handle = _pywht.features_MacroDeclaration_CTor()
			_pywht.IncRef(self.handle)
			if  0 < len(args):
				self.Macro = args[0]
			if "Macro" in kwargs:
				self.Macro = kwargs["Macro"]
			if  1 < len(args):
				self.Description = args[1]
			if "Description" in kwargs:
				self.Description = kwargs["Description"]
			if  2 < len(args):
				self.Value = args[2]
			if "Value" in kwargs:
				self.Value = kwargs["Value"]
	def __del__(self):
		_pywht.DecRef(self.handle)
	def __str__(self):
		pr = [(p, getattr(self, p)) for p in dir(self) if not p.startswith('__')]
		sv = 'features.MacroDeclaration{'
		first = True
		for v in pr:
			if callable(v[1]):
				continue
			if first:
				first = False
			else:
				sv += ', '
			sv += v[0] + '=' + str(v[1])
		return sv + '}'
	def __repr__(self):
		pr = [(p, getattr(self, p)) for p in dir(self) if not p.startswith('__')]
		sv = 'features.MacroDeclaration ( '
		for v in pr:
			if not callable(v[1]):
				sv += v[0] + '=' + str(v[1]) + ', '
		return sv + ')'
	@property
	def Macro(self):
		return _pywht.features_MacroDeclaration_Macro_Get(self.handle)
	@Macro.setter
	def Macro(self, value):
		if isinstance(value, go.GoClass):
			_pywht.features_MacroDeclaration_Macro_Set(self.handle, value.handle)
		else:
			_pywht.features_MacroDeclaration_Macro_Set(self.handle, value)
	@property
	def Description(self):
		return _pywht.features_MacroDeclaration_Description_Get(self.handle)
	@Description.setter
	def Description(self, value):
		if isinstance(value, go.GoClass):
			_pywht.features_MacroDeclaration_Description_Set(self.handle, value.handle)
		else:
			_pywht.features_MacroDeclaration_Description_Set(self.handle, value)
	@property
	def Value(self):
		return _pywht.features_MacroDeclaration_Value_Get(self.handle)
	@Value.setter
	def Value(self, value):
		if isinstance(value, go.GoClass):
			_pywht.features_MacroDeclaration_Value_Set(self.handle, value.handle)
		else:
			_pywht.features_MacroDeclaration_Value_Set(self.handle, value)

# Python type for struct features.TableVarDeclaration
class TableVarDeclaration(go.GoClass):
	""""""
	def __init__(self, *args, **kwargs):
		"""
		handle=A Go-side object is always initialized with an explicit handle=arg
		otherwise parameters can be unnamed in order of field names or named fields
		in which case a new Go object is constructed first
		"""
		if len(kwargs) == 1 and 'handle' in kwargs:
			self.handle = kwargs['handle']
			_pywht.IncRef(self.handle)
		elif len(args) == 1 and isinstance(args[0], go.GoClass):
			self.handle = args[0].handle
			_pywht.IncRef(self.handle)
		else:
			self.handle = _pywht.features_TableVarDeclaration_CTor()
			_pywht.IncRef(self.handle)
			if  0 < len(args):
				self.TableVar = args[0]
			if "TableVar" in kwargs:
				self.TableVar = kwargs["TableVar"]
			if  1 < len(args):
				self.Description = args[1]
			if "Description" in kwargs:
				self.Description = kwargs["Description"]
			if  2 < len(args):
				self.Filter = args[2]
			if "Filter" in kwargs:
				self.Filter = kwargs["Filter"]
			if  3 < len(args):
				self.Value = args[3]
			if "Value" in kwargs:
				self.Value = kwargs["Value"]
	def __del__(self):
		_pywht.DecRef(self.handle)
	def __str__(self):
		pr = [(p, getattr(self, p)) for p in dir(self) if not p.startswith('__')]
		sv = 'features.TableVarDeclaration{'
		first = True
		for v in pr:
			if callable(v[1]):
				continue
			if first:
				first = False
			else:
				sv += ', '
			sv += v[0] + '=' + str(v[1])
		return sv + '}'
	def __repr__(self):
		pr = [(p, getattr(self, p)) for p in dir(self) if not p.startswith('__')]
		sv = 'features.TableVarDeclaration ( '
		for v in pr:
			if not callable(v[1]):
				sv += v[0] + '=' + str(v[1]) + ', '
		return sv + ')'
	@property
	def TableVar(self):
		return _pywht.features_TableVarDeclaration_TableVar_Get(self.handle)
	@TableVar.setter
	def TableVar(self, value):
		if isinstance(value, go.GoClass):
			_pywht.features_TableVarDeclaration_TableVar_Set(self.handle, value.handle)
		else:
			_pywht.features_TableVarDeclaration_TableVar_Set(self.handle, value)
	@property
	def Description(self):
		return _pywht.features_TableVarDeclaration_Description_Get(self.handle)
	@Description.setter
	def Description(self, value):
		if isinstance(value, go.GoClass):
			_pywht.features_TableVarDeclaration_Description_Set(self.handle, value.handle)
		else:
			_pywht.features_TableVarDeclaration_Description_Set(self.handle, value)
	@property
	def Filter(self):
		return _pywht.features_TableVarDeclaration_Filter_Get(self.handle)
	@Filter.setter
	def Filter(self, value):
		if isinstance(value, go.GoClass):
			_pywht.features_TableVarDeclaration_Filter_Set(self.handle, value.handle)
		else:
			_pywht.features_TableVarDeclaration_Filter_Set(self.handle, value)
	@property
	def Value(self):
		return _pywht.features_TableVarDeclaration_Value_Get(self.handle)
	@Value.setter
	def Value(self, value):
		if isinstance(value, go.GoClass):
			_pywht.features_TableVarDeclaration_Value_Set(self.handle, value.handle)
		else:
			_pywht.features_TableVarDeclaration_Value_Set(self.handle, value)

# Python type for struct features.EntityFeaturesModel
class EntityFeaturesModel(base.BaseWhtModel):
	""""""
	def __init__(self, *args, **kwargs):
		"""
		handle=A Go-side object is always initialized with an explicit handle=arg
		otherwise parameters can be unnamed in order of field names or named fields
		in which case a new Go object is constructed first
		"""
		if len(kwargs) == 1 and 'handle' in kwargs:
			self.handle = kwargs['handle']
			_pywht.IncRef(self.handle)
		elif len(args) == 1 and isinstance(args[0], go.GoClass):
			self.handle = args[0].handle
			_pywht.IncRef(self.handle)
		else:
			self.handle = _pywht.features_EntityFeaturesModel_CTor()
			_pywht.IncRef(self.handle)
			if  1 < len(args):
				self.Inputs = args[1]
			if "Inputs" in kwargs:
				self.Inputs = kwargs["Inputs"]
			if  2 < len(args):
				self.IdStitcher = args[2]
			if "IdStitcher" in kwargs:
				self.IdStitcher = kwargs["IdStitcher"]
	def __del__(self):
		_pywht.DecRef(self.handle)
	def __str__(self):
		pr = [(p, getattr(self, p)) for p in dir(self) if not p.startswith('__')]
		sv = 'features.EntityFeaturesModel{'
		first = True
		for v in pr:
			if callable(v[1]):
				continue
			if first:
				first = False
			else:
				sv += ', '
			sv += v[0] + '=' + str(v[1])
		return sv + '}'
	def __repr__(self):
		pr = [(p, getattr(self, p)) for p in dir(self) if not p.startswith('__')]
		sv = 'features.EntityFeaturesModel ( '
		for v in pr:
			if not callable(v[1]):
				sv += v[0] + '=' + str(v[1]) + ', '
		return sv + ')'
	@property
	def Inputs(self):
		"""Inputs
		"""
		return Slice_identity_IdStitchingModelInput(handle=_pywht.features_EntityFeaturesModel_Inputs_Get(self.handle))
	@Inputs.setter
	def Inputs(self, value):
		if isinstance(value, go.GoClass):
			_pywht.features_EntityFeaturesModel_Inputs_Set(self.handle, value.handle)
		else:
			raise TypeError("supplied argument type {t} is not a go.GoClass".format(t=type(value)))
	@property
	def IdStitcher(self):
		return identity.IdStitchingModel(handle=_pywht.features_EntityFeaturesModel_IdStitcher_Get(self.handle))
	@IdStitcher.setter
	def IdStitcher(self, value):
		if isinstance(value, go.GoClass):
			_pywht.features_EntityFeaturesModel_IdStitcher_Set(self.handle, value.handle)
		else:
			raise TypeError("supplied argument type {t} is not a go.GoClass".format(t=type(value)))
	def Compile(self, whtContext, goRun=False):
		"""Compile(object whtContext) """
		_pywht.features_EntityFeaturesModel_Compile(self.handle, whtContext.handle, goRun)

# Python type for struct features.FeatureIdentifierDeclaration
class FeatureIdentifierDeclaration(TableVarDeclaration):
	""""""
	def __init__(self, *args, **kwargs):
		"""
		handle=A Go-side object is always initialized with an explicit handle=arg
		otherwise parameters can be unnamed in order of field names or named fields
		in which case a new Go object is constructed first
		"""
		if len(kwargs) == 1 and 'handle' in kwargs:
			self.handle = kwargs['handle']
			_pywht.IncRef(self.handle)
		elif len(args) == 1 and isinstance(args[0], go.GoClass):
			self.handle = args[0].handle
			_pywht.IncRef(self.handle)
		else:
			self.handle = _pywht.features_FeatureIdentifierDeclaration_CTor()
			_pywht.IncRef(self.handle)
	def __del__(self):
		_pywht.DecRef(self.handle)
	def __str__(self):
		pr = [(p, getattr(self, p)) for p in dir(self) if not p.startswith('__')]
		sv = 'features.FeatureIdentifierDeclaration{'
		first = True
		for v in pr:
			if callable(v[1]):
				continue
			if first:
				first = False
			else:
				sv += ', '
			sv += v[0] + '=' + str(v[1])
		return sv + '}'
	def __repr__(self):
		pr = [(p, getattr(self, p)) for p in dir(self) if not p.startswith('__')]
		sv = 'features.FeatureIdentifierDeclaration ( '
		for v in pr:
			if not callable(v[1]):
				sv += v[0] + '=' + str(v[1]) + ', '
		return sv + ')'

# Python type for struct features.FeatureTableBuildSpec
class FeatureTableBuildSpec(identity.IdStitchingBuildSpec):
	"""Feature table YAML is parsed using this struct.\n"""
	def __init__(self, *args, **kwargs):
		"""
		handle=A Go-side object is always initialized with an explicit handle=arg
		otherwise parameters can be unnamed in order of field names or named fields
		in which case a new Go object is constructed first
		"""
		if len(kwargs) == 1 and 'handle' in kwargs:
			self.handle = kwargs['handle']
			_pywht.IncRef(self.handle)
		elif len(args) == 1 and isinstance(args[0], go.GoClass):
			self.handle = args[0].handle
			_pywht.IncRef(self.handle)
		else:
			self.handle = _pywht.features_FeatureTableBuildSpec_CTor()
			_pywht.IncRef(self.handle)
			if  1 < len(args):
				self.Features = args[1]
			if "Features" in kwargs:
				self.Features = kwargs["Features"]
	def __del__(self):
		_pywht.DecRef(self.handle)
	def __str__(self):
		pr = [(p, getattr(self, p)) for p in dir(self) if not p.startswith('__')]
		sv = 'features.FeatureTableBuildSpec{'
		first = True
		for v in pr:
			if callable(v[1]):
				continue
			if first:
				first = False
			else:
				sv += ', '
			sv += v[0] + '=' + str(v[1])
		return sv + '}'
	def __repr__(self):
		pr = [(p, getattr(self, p)) for p in dir(self) if not p.startswith('__')]
		sv = 'features.FeatureTableBuildSpec ( '
		for v in pr:
			if not callable(v[1]):
				sv += v[0] + '=' + str(v[1]) + ', '
		return sv + ')'
	@property
	def Features(self):
		return Slice_features_FeatureIdentifierDeclaration(handle=_pywht.features_FeatureTableBuildSpec_Features_Get(self.handle))
	@Features.setter
	def Features(self, value):
		if isinstance(value, go.GoClass):
			_pywht.features_FeatureTableBuildSpec_Features_Set(self.handle, value.handle)
		else:
			raise TypeError("supplied argument type {t} is not a go.GoClass".format(t=type(value)))


# ---- Slices ---


# ---- Maps ---


# ---- Constructors ---


# ---- Functions ---


